#ifndef SNEeSe_cpu_h
#define SNEeSe_cpu_h

#include "misc.h"

EXTERN unsigned char E0_Setup_Restore_Flags_Table[256]
 asm("E0_Setup_Restore_Flags_Table");
EXTERN unsigned char E1_Setup_Flags_Table[256]
 asm("E1_Setup_Flags_Table");
EXTERN unsigned char E1_Restore_Flags_Table[256]
 asm("E1_Restore_Flags_Table");
EXTERN unsigned long IntDone asm("IntDone");
EXTERN unsigned long SNES_Cycles asm("SNES_Cycles");
EXTERN unsigned long PB_Read asm("PB_Read");
EXTERN unsigned long SPC_Fixup asm("SPC_Fixup");
EXTERN unsigned char TM_MASK asm("TM_MASK");
EXTERN unsigned char PaletteChanged asm("PaletteChanged");
EXTERN void DO_INVALID(void) asm("DO_INVALID");

EXTERN void Reset_CPU(void);
EXTERN void Do_CPU(void);
EXTERN void NMI(void) asm("NMI");
EXTERN void NMI_NoRender(void) asm("NMI_NoRender");

/* Interrupt vectors */
EXTERN unsigned long NMI_Nvector,NMI_Evector;
EXTERN unsigned long IRQ_Nvector,IRQ_Evector;
EXTERN unsigned long COP_Nvector,COP_Evector;
EXTERN unsigned long BRK_Nvector;

/* CPU registers and etc. */
EXTERN unsigned long _65816_X;
EXTERN unsigned long _65816_Y;  // X and Y indices
EXTERN unsigned long _65816_A;  // Accumulator
EXTERN unsigned long _65816_P;  // Flags register
EXTERN unsigned long _65816_S;  // Stack pointer
EXTERN unsigned long _65816_D;  // Direct Address
EXTERN unsigned long _65816_PC; // Program counter
EXTERN unsigned long _65816_DB_Shifted;
EXTERN unsigned long _65816_PB_Shifted;
#define _65816_DB ((unsigned char) _65816_DB_Shifted >> 16)
#define _65816_PB ((unsigned char) _65816_PB_Shifted >> 16)
EXTERN unsigned long IRQTrip;
EXTERN unsigned long LineCycles;    // Cycles per scanline

EXTERN void *Event_Handler_Table;
EXTERN void (*Event_Handler_Table_NTSC[])(void);
EXTERN void (*Event_Handler_Table_PAL[])(void);
#endif /* SNEeSe_cpu_h */
