/*

 65c816 opcodes 0x10-0x1F:
    10: BPL r       2,2
    11: ORA (d),y   2,5
    12: ORA (d)     2,5
    13: ORA (d,s),y 2,7
    14: TRB d       2,5
    15: ORA d,x     2,4
    16: ASL d,x     2,6
    17: ORA [d],y   2,6
    18: CLC i       1,2
    19: ORA a,y     3,4
    1A: INC A       1,2
    1B: TCS i       1,2
    1C: TRB a       3,6
    1D: ORA a,x     3,4
    1E: ASL a,x     3,7
    1F: ORA al,x    4,5
*/

/* 10 */

ALIGN
ALL_BPL:
    BFC SNES_FLAG_N
    jmp CPU_RETURN

/* 11 */

ALIGN
EM_ORA_OdO_y:
    EM_ORA Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_ORA_OdO_y:
    E0_ORA Direct_Indirect_Indexed
    jmp CPU_RETURN

/* 12 */

ALIGN
EM_ORA_OdO:
    EM_ORA Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_ORA_OdO:
    E0_ORA Direct_Indirect
    jmp CPU_RETURN

/* 13 */

ALIGN
EM_ORA_Od_sO_y:
    EM_ORA Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_ORA_Od_sO_y:
    E0_ORA Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* 14 */

ALIGN
EM_TRB_d:
    EM_TRB Direct
    jmp CPU_RETURN
ALIGN
E0_TRB_d:
    E0_TRB Direct
    jmp CPU_RETURN

/* 15 */

ALIGN
EM_ORA_d_x:
    EM_ORA Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_ORA_d_x:
    E0_ORA Direct_Index_X
    jmp CPU_RETURN

/* 16 */

ALIGN
EM_ASL_d_x:
    EM_ASL Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_ASL_d_x:
    E0_ASL Direct_Index_X
    jmp CPU_RETURN

/* 17 */

ALIGN
EM_ORA_IdI_y:
    EM_ORA Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_ORA_IdI_y:
    E0_ORA Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* 18 */

ALIGN
ALL_CLC:
    movw %bx,_PC
    CLR_FLAG SNES_FLAG_C
    jmp CPU_RETURN

/* 19 */

ALIGN
EM_ORA_a_y:
    EM_ORA Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_ORA_a_y:
    E0_ORA Absolute_Index_Y
    jmp CPU_RETURN

/* 1A */

ALIGN
EM_INA:
    movw %bx,_PC
    incb _A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_INA:
    movw %bx,_PC
    incw _A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 1B */

ALIGN
E0_TCS:
    movw %bx,_PC
    movl _A,%eax
    movl %eax,_S
    jmp CPU_RETURN
ALIGN
E1_TCS:
    movw %bx,_PC
    movb _A,%al
    movb %al,_S
    jmp CPU_RETURN

/* 1C */

ALIGN
EM_TRB_a:
    EM_TRB Absolute
    jmp CPU_RETURN
ALIGN
E0_TRB_a:
    E0_TRB Absolute
    jmp CPU_RETURN

/* 1D */

ALIGN
EM_ORA_a_x:
    EM_ORA Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_ORA_a_x:
    E0_ORA Absolute_Index_X
    jmp CPU_RETURN

/* 1E */

ALIGN
EM_ASL_a_x:
    EM_ASL Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_ASL_a_x:
    E0_ASL Absolute_Index_X
    jmp CPU_RETURN

/* 1F */

ALIGN
EM_ORA_al_x:
    EM_ORA Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_ORA_al_x:
    E0_ORA Absolute_Long_Index_X
    jmp CPU_RETURN
