/*

 65c816 opcodes 0x30-0x3F:
    30: BMI r       2,2
    31: AND (d),y   2,5
    32: AND (d)     2,5
    33: AND (d,s),y 2,7
    34: BIT d,x     2,4
    35: AND d,x     2,4
    36: ROL d,x     2,6
    37: AND [d],y   2,6
    38: SEC i       1,2
    39: AND a,y     3,4
    3A: DEC A       1,2
    3B: TSC i       1,2
    3C: BIT a,x     3,4
    3D: AND a,x     3,4
    3E: ROL a,x     3,7
    3F: AND al,x    4,5
*/

/* 30 */

ALIGN
ALL_BMI:
    BFS SNES_FLAG_N
    jmp CPU_RETURN

/* 31 */

ALIGN
EM_AND_OdO_y:
    EM_AND Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_AND_OdO_y:
    E0_AND Direct_Indirect_Indexed
    jmp CPU_RETURN

/* 32 */

ALIGN
EM_AND_OdO:
    EM_AND Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_AND_OdO:
    E0_AND Direct_Indirect
    jmp CPU_RETURN

/* 33 */

ALIGN
EM_AND_Od_sO_y:
    EM_AND Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_AND_Od_sO_y:
    E0_AND Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* 34 */

ALIGN
EM_BIT_d_x:
    EM_BIT Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_BIT_d_x:
    E0_BIT Direct_Index_X
    jmp CPU_RETURN

/* 35 */

ALIGN
EM_AND_d_x:
    EM_AND Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_AND_d_x:
    E0_AND Direct_Index_X
    jmp CPU_RETURN

/* 36 */

ALIGN
EM_ROL_d_x:
    EM_ROL Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_ROL_d_x:
    E0_ROL Direct_Index_X
    jmp CPU_RETURN

/* 37 */

ALIGN
EM_AND_IdI_y:
    EM_AND Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_AND_IdI_y:
    E0_AND Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* 38 */

ALIGN
ALL_SEC:			/* Set Carry Flag */
    movw %bx,_PC
    SET_FLAG SNES_FLAG_C
    jmp CPU_RETURN

/* 39 */

ALIGN
EM_AND_a_y:
    EM_AND Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_AND_a_y:
    E0_AND Absolute_Index_Y
    jmp CPU_RETURN

/* 3A */

ALIGN
EM_DEA:
    movw %bx,_PC
    decb _A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_DEA:
    movw %bx,_PC
    decw _A
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 3B */

ALIGN
ALL_TSC:
    movw %bx,_PC
    movl _S,%eax
    movw %ax,_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 3C */

ALIGN
EM_BIT_a_x:
    EM_BIT Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_BIT_a_x:
    E0_BIT Absolute_Index_X
    jmp CPU_RETURN

/* 3D */

ALIGN
EM_AND_a_x:
    EM_AND Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_AND_a_x:
    E0_AND Absolute_Index_X
    jmp CPU_RETURN

/* 3E */

ALIGN
EM_ROL_a_x:
    EM_ROL Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_ROL_a_x:
    E0_ROL Absolute_Index_X
    jmp CPU_RETURN

/* 3F */

ALIGN
EM_AND_al_x:
    EM_AND Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_AND_al_x:
    E0_AND Absolute_Long_Index_X
    jmp CPU_RETURN
