/*

 65c816 opcodes 0x50-0x5F:
    50: BVC r       2,2
    51: EOR (d),y   2,5
    52: EOR (d)     2,5
    53: EOR (d,s),y 2,7
    54: MVN xya     3,7
    55: EOR d,x     2,4
    56: LSR d,x     2,6
    57: EOR [d],y   2,6
    58: CLI i       1,2
    59: EOR a,y     3,4
    5A: PHY s       1,2
    5B: TCD i       1,2
    5C: JML al      4,4
    5D: EOR a,x     3,4
    5E: LSR a,x     3,7
    5F: EOR al,x    4,5
*/

/* 50 */

ALIGN
ALL_BVC:
    BFC SNES_FLAG_V
    jmp CPU_RETURN

/* 51 */

ALIGN
EM_EOR_OdO_y:
    EM_EOR Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_EOR_OdO_y:
    E0_EOR Direct_Indirect_Indexed
    jmp CPU_RETURN

/* 52 */

ALIGN
EM_EOR_OdO:
    EM_EOR Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_EOR_OdO:
    E0_EOR Direct_Indirect
    jmp CPU_RETURN

/* 53 */

ALIGN
EM_EOR_Od_sO_y:
    EM_EOR Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_EOR_Od_sO_y:
    E0_EOR Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* 54 */

ALIGN
E0_MVN:
    movb 1(%esi),%al    // Dest bank
    addl $2,%ebx
    movb %al,_DB
    movb 2(%esi),%al    // Src bank
    movw %bx,_PC
    movl _DB_Shifted,%edx
    shll $16,%eax
    movw _Y,%dx         // Dest Address
    movw _X,%ax         // Src Address
    movl %eax,%ebx
    incl %eax
    movw %ax,_X
    GET_BYTE
    movl %edx,%ebx
    incl %edx
    movw %dx,_Y
    SET_BYTE
    movl _A,%eax
    testl %eax,%eax
    jz 0f
    subw $3,_PC
0:  decl %eax
    movw %ax,_A
    jmp CPU_RETURN
	
ALIGN
EX_MVN:
    movb 1(%esi),%al    // Dest bank
    addl $2,%ebx
    movb %al,_DB
    movb 2(%esi),%al    // Src bank
    movw %bx,_PC
    movl _DB_Shifted,%edx
    shll $16,%eax
    movb _Y,%dl         // Dest Address
    movb _X,%al         // Src Address
    movl %eax,%ebx
    incl %eax
    movb %al,_X
    GET_BYTE
    movl %edx,%ebx
    incl %edx
    movb %dl,_Y
    SET_BYTE
    movl _A,%eax
    testl %eax,%eax
    jz 0f
    subw $3,_PC
0:  decl %eax
    movw %ax,_A
    jmp CPU_RETURN

/* 55 */

ALIGN
EM_EOR_d_x:
    EM_EOR Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_EOR_d_x:
    E0_EOR Direct_Index_X
    jmp CPU_RETURN

/* 56 */

ALIGN
EM_LSR_d_x:
    EM_LSR Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_LSR_d_x:
    E0_LSR Direct_Index_X
    jmp CPU_RETURN

/* 57 */

ALIGN
EM_EOR_IdI_y:
    EM_EOR Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_EOR_IdI_y:
    E0_EOR Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* 58 */

ALIGN
ALL_CLI:
    movw %bx,_PC
    CLR_FLAG SNES_FLAG_I
    movb IRQ_pin,%al
    testb %al,%al
    jz  CPU_RETURN
    pushl $CPU_RETURN
    JUMP_NOT_FLAG SNES_FLAG_E,E0_IRQ
    jmp E1_IRQ

/* 59 */

ALIGN
EM_EOR_a_y:
    EM_EOR Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_EOR_a_y:
    E0_EOR Absolute_Index_Y
    jmp CPU_RETURN

/* 5A */

ALIGN
E0_PHY:
    movw %bx,_PC
    movw _Y,%ax
	E0_PUSH_W
    jmp CPU_RETURN

ALIGN
EX_PHY:
    movw %bx,_PC
    movw _Y,%ax
	E0_PUSH_B
    jmp CPU_RETURN

ALIGN
E1_PHY:
    movw %bx,_PC
    movw _Y,%ax
	E1_PUSH_B
    jmp CPU_RETURN

/* 5B */

ALIGN
ALL_TCD:
    movw %bx,_PC
    movl _A,%eax
    movl %eax,_D
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 5C */

ALIGN
ALL_JML_al:
    movb 1(%esi),%bl
    movb 2(%esi),%ah
    movb %bl,_PC
    movb %ah,_PC+1
    xorl %ebx,%ebx
    movb 3(%esi),%bl
    movb %bl,_PB
    testb %bl,MEMSEL    // Check bus speed against PB
    movb $5,%dl
    jnz 0f
    movb $4,%dl
0:  addb %ah,%ah
    movb %dl,CycleTable // Update bus speed
    movl _Read_BankMapping(,%ebx,4),%eax
    adcl %ebx,%ebx
    movl %eax,_PB_Read
    movl _Read_BankOffset(,%ebx,4),%eax
    movl %eax,_PBOffset
    jmp CPU_RETURN

/* 5D */

ALIGN
EM_EOR_a_x:
    EM_EOR Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_EOR_a_x:
    E0_EOR Absolute_Index_X
    jmp CPU_RETURN

/* 5E */

ALIGN
EM_LSR_a_x:
    EM_LSR Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_LSR_a_x:
    E0_LSR Absolute_Index_X
    jmp CPU_RETURN

/* 5F */

ALIGN
EM_EOR_al_x:
    EM_EOR Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_EOR_al_x:
    E0_EOR Absolute_Long_Index_X
    jmp CPU_RETURN

