/*

 65c816 opcodes 0x70-0x7F:
    70: BVS r       2,2
    71: ADC (d),y   2,5
    72: ADC (d)     2,5
    73: ADC (d,s),y 2,7
    74: STZ d,x     2,4
    75: ADC d,x     2,4
    76: ROR d,x     2,6
    77: EOR [d],y   2,6
    78: SEI i       1,2
    79: ADC a,y     3,4
    7A: PLY s       1,4
    7B: TDC i       1,2
    7C: JMP (a,x)   3,6
    7D: ADC a,x     3,4
    7E: ROR a,x     3,7
    7F: ADC al,x    4,5
*/

/* 70 */

ALIGN
ALL_BVS:
    BFS SNES_FLAG_V
    jmp CPU_RETURN

/* 71 */

ALIGN
EM_ADC_OdO_y:
    EM_ADC Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_ADC_OdO_y:
    E0_ADC Direct_Indirect_Indexed
    jmp CPU_RETURN

/* 72 */

ALIGN
EM_ADC_OdO:
    EM_ADC Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_ADC_OdO:
    E0_ADC Direct_Indirect
    jmp CPU_RETURN

/* 73 */

ALIGN
EM_ADC_Od_sO_y:
    EM_ADC Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_ADC_Od_sO_y:
    E0_ADC Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* 74 */

ALIGN
EM_STZ_d_x:
    EM_STZ Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_STZ_d_x:
    E0_STZ Direct_Index_X
    jmp CPU_RETURN

/* 75 */

ALIGN
EM_ADC_d_x:
    EM_ADC Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_ADC_d_x:
    E0_ADC Direct_Index_X
    jmp CPU_RETURN

/* 76 */

ALIGN
EM_ROR_d_x:
    EM_ROR Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_ROR_d_x:
    E0_ROR Direct_Index_X
    jmp CPU_RETURN

/* 77 */

ALIGN
EM_ADC_IdI_y:
    EM_ADC Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_ADC_IdI_y:
    E0_ADC Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* 78 */

ALIGN
ALL_SEI:
    movw %bx,_PC
	SET_FLAG SNES_FLAG_I 
    jmp CPU_RETURN

/* 79 */

ALIGN
EM_ADC_a_y:
    EM_ADC Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_ADC_a_y:
    E0_ADC Absolute_Index_Y
    jmp CPU_RETURN

/* 7A */

ALIGN
E0_PLY:
    movw %bx,_PC
    E0_PULL_W
    movw %ax,_Y
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
EX_PLY:
    movw %bx,_PC
    E0_PULL_B
    movb %al,_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E1_PLY:
    movw %bx,_PC
    E1_PULL_B
    movb %al,_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 7B */

ALIGN
ALL_TDC:
    movw %bx,_PC
    movl _D,%eax
    movl %eax,_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 7C */

ALIGN
ALL_JMP_Oa_xO:
    ADDR_Absolute_Indexed_Indirect
    xorl %ebx,%ebx
    addb %al,%al
    movb _PB,%bl
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    movl %eax,_PBOffset
    jmp CPU_RETURN

/* 7D */

ALIGN
EM_ADC_a_x:
    EM_ADC Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_ADC_a_x:
    E0_ADC Absolute_Index_X
    jmp CPU_RETURN

/* 7E */

ALIGN
EM_ROR_a_x:
    EM_ROR Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_ROR_a_x:
    E0_ROR Absolute_Index_X
    jmp CPU_RETURN

/* 7F */

ALIGN
EM_ADC_al_x:
    EM_ADC Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_ADC_al_x:
    E0_ADC Absolute_Long_Index_X
    jmp CPU_RETURN

