/*

 65c816 opcodes 0x80-0x8F:
    80: BRA r       2,2
    81: STA (d,x)   2,6
    82: BRL rl      3,3
    83: STA d,s     2,4
    84: STY d       2,3
    85: STA d       2,3
    86: STX d       2,3
    87: STA [d]     2,6
    88: DEY i       1,2
    89: BIT #       2,2
    8A: TXA i       1,2
    8B: PHB s       1,3
    8C: STY a       3,4
    8D: STA a       3,4
    8E: STX a       3,4
    8F: STA al      4,5
*/

/* 80 */

ALIGN
ALL_BRA:
    movsbl 1(%esi),%eax
    incl %eax
    addl %ebx,%eax
    movw %ax,_PC
    jmp CPU_RETURN

/* 81 */

ALIGN
EM_STA_Od_xO:
    EM_STA Direct_Indexed_Indirect
    jmp CPU_RETURN
ALIGN
E0_STA_Od_xO:
    E0_STA Direct_Indexed_Indirect
    jmp CPU_RETURN

/* 82 */

ALIGN
ALL_BRL:                // Branch always long (-32768 to 32767)
    movb 1(%esi),%al
    addl $2,%ebx
    movb 2(%esi),%ah
    addl %ebx,%eax
    xorl %ebx,%ebx
    movw %ax,_PC
    addb %ah,%ah
    movb _PB,%bl
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    movl %eax,_PBOffset
    jmp CPU_RETURN

/* 83 */

ALIGN
EM_STA_d_s:
    EM_STA Stack_Relative
    jmp CPU_RETURN
ALIGN
E0_STA_d_s:
    E0_STA Stack_Relative
    jmp CPU_RETURN

/* 84 */

ALIGN
EX_STY_d:
    EX_STY Direct
    jmp CPU_RETURN
ALIGN
E0_STY_d:
    E0_STY Direct
    jmp CPU_RETURN

/* 85 */

ALIGN
EM_STA_d:
    EM_STA Direct
    jmp CPU_RETURN
ALIGN
E0_STA_d:
    E0_STA Direct
    jmp CPU_RETURN

/* 86 */

ALIGN
EX_STX_d:
    EX_STX Direct
    jmp CPU_RETURN
ALIGN
E0_STX_d:
    E0_STX Direct
    jmp CPU_RETURN

/* 87 */

ALIGN
EM_STA_IdI:
    EM_STA Direct_Indirect_Long
    jmp CPU_RETURN
ALIGN
E0_STA_IdI:
    E0_STA Direct_Indirect_Long
    jmp CPU_RETURN

/* 88 */

ALIGN
EX_DEY:
    movw %bx,_PC
    decb _Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_DEY:
    movw %bx,_PC
    decw _Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 89 */    // Differs from norm, only sets Z flag

ALIGN
EM_BIT_i:
    movb 1(%esi),%al
    incl %ebx
    testb _A,%al
    STORE_FLAGS (SNES_FLAG_Z)
    movw %bx,_PC
    jmp CPU_RETURN
ALIGN
E0_BIT_i:
    movb 1(%esi),%al
    addl $2,%ebx
    movb 2(%esi),%ah
    testw _A,%ax
    STORE_FLAGS (SNES_FLAG_Z)
    movw %bx,_PC
    jmp CPU_RETURN

/* 8A */

ALIGN
EM_TXA:
    movw %bx,_PC
    movb _X,%al
    movb %al,_A
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TXA:
    movw %bx,_PC
    movl _X,%eax
    movl %eax,_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 8B */

ALIGN
E0_PHB:
    movw %bx,_PC
    movb _DB,%al
	E0_PUSH_B
    jmp CPU_RETURN

ALIGN
E1_PHB:
    movw %bx,_PC
    movb _DB,%al
	E1_PUSH_B
    jmp CPU_RETURN

/* 8C */

ALIGN
EX_STY_a:
    EX_STY Absolute
    jmp CPU_RETURN
ALIGN
E0_STY_a:
    E0_STY Absolute
    jmp CPU_RETURN

/* 8D */

ALIGN
EM_STA_a:
    EM_STA Absolute
    jmp CPU_RETURN
ALIGN
E0_STA_a:
    E0_STA Absolute
    jmp CPU_RETURN

/* 8E */

ALIGN
EX_STX_a:
    EX_STX Absolute
    jmp CPU_RETURN
ALIGN
E0_STX_a:
    E0_STX Absolute
    jmp CPU_RETURN

/* 8F */

ALIGN
EM_STA_al:
    EM_STA Absolute_Long
    jmp CPU_RETURN
ALIGN
E0_STA_al:
    E0_STA Absolute_Long
    jmp CPU_RETURN

