/*

 65c816 opcodes 0x90-0x9F:
    90: BCC r       2,2
    91: STA (d),y   2,6
    92: STA (d)     2,5
    93: STA (d,s),y 2,7
    94: STY d,x     2,4
    95: STA d,x     2,4
    96: STX d,x     2,4
    97: STA [d],y   2,6
    98: TYA i       1,2
    99: STA a,y     3,5
    9A: TXS i       1,2
    9B: TXY i       1,2
    9C: STZ a       3,4
    9D: STA a,x     3,5
    9E: STZ a,x     3,5
    9F: STA al,x    4,5
*/

/* 90 */

ALIGN
ALL_BCC:
    BFC SNES_FLAG_C
    jmp CPU_RETURN

/* 91 */

ALIGN
EM_STA_OdO_y:
    EM_STA Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_STA_OdO_y:
    E0_STA Direct_Indirect_Indexed
    jmp CPU_RETURN

/* 92 */

ALIGN
EM_STA_OdO:
    EM_STA Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_STA_OdO:
    E0_STA Direct_Indirect
    jmp CPU_RETURN

/* 93 */

ALIGN
EM_STA_Od_sO_y:
    EM_STA Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_STA_Od_sO_y:
    E0_STA Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* 94 */

ALIGN
EX_STY_d_x:
    EX_STY Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_STY_d_x:
    E0_STY Direct_Index_X
    jmp CPU_RETURN

/* 95 */

ALIGN
EM_STA_d_x:
    EM_STA Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_STA_d_x:
    E0_STA Direct_Index_X
    jmp CPU_RETURN

/* 96 */

ALIGN
EX_STX_d_y:
    EX_STX Direct_Index_Y
    jmp CPU_RETURN
ALIGN
E0_STX_d_y:
    E0_STX Direct_Index_Y
    jmp CPU_RETURN

/* 97 */

ALIGN
EM_STA_IdI_y:
    EM_STA Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_STA_IdI_y:
    E0_STA Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* 98 */

ALIGN
EM_TYA:
    movw %bx,_PC
    movb _Y,%al
    movb %al,_A
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TYA:
    movw %bx,_PC
    movl _Y,%eax
    movl %eax,_A
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 99 */

ALIGN
EM_STA_a_y:
    EM_STA Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_STA_a_y:
    E0_STA Absolute_Index_Y
    jmp CPU_RETURN

/* 9A */

ALIGN
E0_TXS:
    movw %bx,_PC
    movl _X,%eax
    movl %eax,_S
    jmp CPU_RETURN
ALIGN
E1_TXS:
    movw %bx,_PC
    movb _X,%al
    movb %al,_S
    jmp CPU_RETURN

/* 9B */

ALIGN
EX_TXY:
    movw %bx,_PC
    movb _X,%al
    movb %al,_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TXY:
    movw %bx,_PC
    movl _X,%eax
    movl %eax,_Y
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* 9C */

ALIGN
EM_STZ_a:
    EM_STZ Absolute
    jmp CPU_RETURN
ALIGN
E0_STZ_a:
    E0_STZ Absolute
    jmp CPU_RETURN

/* 9D */

ALIGN
EM_STA_a_x:
    EM_STA Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_STA_a_x:
    E0_STA Absolute_Index_X
    jmp CPU_RETURN

/* 9E */

ALIGN
EM_STZ_a_x:
    EM_STZ Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_STZ_a_x:
    E0_STZ Absolute_Index_X
    jmp CPU_RETURN 

/* 9F */

ALIGN
EM_STA_al_x:
    EM_STA Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_STA_al_x:
    E0_STA Absolute_Long_Index_X
    jmp CPU_RETURN

