/*

 65c816 opcodes 0xA0-0xAF:
    A0: LDY #       2,2
    A1: LDA (d,x)   2,6
    A2: LDX #       2,2
    A3: LDA d,s     2,4
    A4: LDY d       2,3
    A5: LDA d       2,3
    A6: LDX d       2,3
    A7: LDA [d]     2,6
    A8: TAY i       1,2
    A9: LDA #       2,2
    AA: TAX i       1,2
    AB: PLB s       1,4
    AC: LDY a       3,4
    AD: LDA a       3,4
    AE: LDX a       3,4
    AF: LDA al      4,5
*/

/* A0 */

ALIGN
EX_LDY_i:
    EX_LDY Immediate
    jmp CPU_RETURN
ALIGN
E0_LDY_i:
    E0_LDY Immediate
    jmp CPU_RETURN

/* A1 */

ALIGN
EM_LDA_Od_xO:
    EM_LDA Direct_Indexed_Indirect
    jmp CPU_RETURN
ALIGN
E0_LDA_Od_xO:
    E0_LDA Direct_Indexed_Indirect
    jmp CPU_RETURN

/* A2 */

ALIGN
EX_LDX_i:
    EX_LDX Immediate
    jmp CPU_RETURN
ALIGN
E0_LDX_i:
    E0_LDX Immediate
    jmp CPU_RETURN

/* A3 */

ALIGN
EM_LDA_d_s:
    EM_LDA Stack_Relative
    jmp CPU_RETURN
ALIGN
E0_LDA_d_s:
    E0_LDA Stack_Relative
    jmp CPU_RETURN

/* A4 */

ALIGN
EX_LDY_d:
    EX_LDY Direct
    jmp CPU_RETURN
ALIGN
E0_LDY_d:
    E0_LDY Direct
    jmp CPU_RETURN

/* A5 */

ALIGN
EM_LDA_d:
    EM_LDA Direct
    jmp CPU_RETURN
ALIGN
E0_LDA_d:
    E0_LDA Direct
    jmp CPU_RETURN

/* A6 */

ALIGN
EX_LDX_d:
    EX_LDX Direct
    jmp CPU_RETURN
ALIGN
E0_LDX_d:
    E0_LDX Direct
    jmp CPU_RETURN

/* A7 */

ALIGN
EM_LDA_IdI:
    EM_LDA Direct_Indirect_Long
    jmp CPU_RETURN
ALIGN
E0_LDA_IdI:
    E0_LDA Direct_Indirect_Long
    jmp CPU_RETURN

/* A8 */

ALIGN
EX_TAY:
    movw %bx,_PC
    movb _A,%al
    movb %al,_Y
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TAY:
    movw %bx,_PC
    movl _A,%eax
    movl %eax,_Y
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* A9 */

ALIGN
EM_LDA_i:
    EM_LDA Immediate
    jmp CPU_RETURN
ALIGN
E0_LDA_i:
    E0_LDA Immediate
    jmp CPU_RETURN

/* AA */

ALIGN
EX_TAX:
    movw %bx,_PC
    movb _A,%al
    movb %al,_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TAX:
    movw %bx,_PC
    movl _A,%eax
    movl %eax,_X
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* AB */

ALIGN
E0_PLB:
    movw %bx,_PC
    E0_PULL_B
    movb %al,_DB
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E1_PLB:
    movw %bx,_PC
    E1_PULL_B
    movb %al,_DB
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* AC */

ALIGN
EX_LDY_a:
    EX_LDY Absolute
    jmp CPU_RETURN
ALIGN
E0_LDY_a:
    E0_LDY Absolute
    jmp CPU_RETURN

/* AD */

ALIGN
EM_LDA_a:
    EM_LDA Absolute
    jmp CPU_RETURN
ALIGN
E0_LDA_a:
    E0_LDA Absolute
    jmp CPU_RETURN

/* AE */

ALIGN
EX_LDX_a:
    EX_LDX Absolute
    jmp CPU_RETURN
ALIGN
E0_LDX_a:
    E0_LDX Absolute
    jmp CPU_RETURN

/* AF */

ALIGN
EM_LDA_al:
    EM_LDA Absolute_Long
    jmp CPU_RETURN
ALIGN
E0_LDA_al:
    E0_LDA Absolute_Long
    jmp CPU_RETURN
