/*

 65c816 opcodes 0xB0-0xBF:
    B0: BCS r       2,2
    B1: LDA (d),y   2,5
    B2: LDA (d)     2,5
    B3: LDA (d,s),y 2,7
    B4: LDY d,x     2,4
    B5: LDA d,x     2,4
    B6: LDX d,y     2,4
    B7: LDA [d],y   2,6
    B8: CLV i       1,2
    B9: LDA a,y     3,4
    BA: TSX i       1,2
    BB: TYX i       1,2
    BC: LDY a,x     3,4
    BD: LDA a,x     3,4
    BE: LDX a,y     3,4
    BF: LDA al,x    4,5
*/

/* B0 */

ALIGN
ALL_BCS:
    BFS SNES_FLAG_C
    jmp CPU_RETURN

/* B1 */

ALIGN
EM_LDA_OdO_y:
    EM_LDA Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_LDA_OdO_y:
    E0_LDA Direct_Indirect_Indexed
    jmp CPU_RETURN

/* B2 */

ALIGN
EM_LDA_OdO:
    EM_LDA Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_LDA_OdO:
    E0_LDA Direct_Indirect
    jmp CPU_RETURN

/* B3 */

ALIGN
EM_LDA_Od_sO_y:
    EM_LDA Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_LDA_Od_sO_y:
    E0_LDA Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* B4 */

ALIGN
EX_LDY_d_x:
    EX_LDY Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_LDY_d_x:
    E0_LDY Direct_Index_X
    jmp CPU_RETURN

/* B5 */

ALIGN
EM_LDA_d_x:
    EM_LDA Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_LDA_d_x:
    E0_LDA Direct_Index_X
    jmp CPU_RETURN

/* B6 */

ALIGN
EX_LDX_d_y:
    EX_LDX Direct_Index_Y
    jmp CPU_RETURN
ALIGN
E0_LDX_d_y:
    E0_LDX Direct_Index_Y
    jmp CPU_RETURN

/* B7 */

ALIGN
EM_LDA_IdI_y:
    EM_LDA Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_LDA_IdI_y:
    E0_LDA Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* B8 */

ALIGN
ALL_CLV:
    movw %bx,_PC
	CLR_FLAG SNES_FLAG_V
    jmp CPU_RETURN

/* B9 */

ALIGN
EM_LDA_a_y:
    EM_LDA Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_LDA_a_y:
    E0_LDA Absolute_Index_Y
    jmp CPU_RETURN

/* BA */

ALIGN
EX_TSX:
    movw %bx,_PC
    movb _S,%al
    movb %al,_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TSX:
    movw %bx,_PC
    movl _S,%eax
    movl %eax,_X
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* BB */

ALIGN
EX_TYX:
    movw %bx,_PC
    movb _Y,%al
    movb %al,_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_TYX:
    movw %bx,_PC
    movl _Y,%eax
    movl %eax,_X
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* BC */

ALIGN
EX_LDY_a_x:
    EX_LDY Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_LDY_a_x:
    E0_LDY Absolute_Index_X
    jmp CPU_RETURN

/* BD */

ALIGN
EM_LDA_a_x:
    EM_LDA Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_LDA_a_x:
    E0_LDA Absolute_Index_X
    jmp CPU_RETURN

/* BE */

ALIGN
EX_LDX_a_y:
    EX_LDX Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_LDX_a_y:
    E0_LDX Absolute_Index_Y
    jmp CPU_RETURN

/* BF */

ALIGN
EM_LDA_al_x:
    EM_LDA Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_LDA_al_x:
    E0_LDA Absolute_Long_Index_X
    jmp CPU_RETURN
