/*

 65c816 opcodes 0xC0-0xCF:
    C0: CPY #       2,2
    C1: CMP (d,x)   2,6
    C2: REP #       2,3
    C3: CMP d,s     2,4
    C4: CPY d       2,3
    C5: CMP d       2,3
    C6: DEC d       2,5
    C7: CMP [d]     2,6
    C8: INY i       1,2
    C9: CMP #       2,2
    CA: DEX i       1,2
    CB: WAI i       1,3
    CC: CPY a       3,4
    CD: CMP a       3,4
    CE: DEC a       3,6
    CF: CMP al      4,5
*/

/* C0 */

ALIGN
EX_CPY_i:
    EX_CPY Immediate
    jmp CPU_RETURN
ALIGN
E0_CPY_i:
    E0_CPY Immediate
    jmp CPU_RETURN

/* C1 */

ALIGN
EM_CMP_Od_xO:
    EM_CMP Direct_Indexed_Indirect
    jmp CPU_RETURN
ALIGN
E0_CMP_Od_xO:
    E0_CMP Direct_Indexed_Indirect
    jmp CPU_RETURN

/* C2 */

ALIGN
E0_REP:
    incl %ebx
    movb 1(%esi),%dl
    movw %bx,_PC
    xorb $0xFF,%dl

    E0_SETUPFLAGS
    andb %dl,%al
    E0_RESTOREFLAGS

    JUMP_FLAG SNES_FLAG_I,0f
    movb IRQ_pin,%al
    testb %al,%al
    jz  0f
    call E0_IRQ
0:
    SET_TABLE_MX

ALIGN
E1_REP:
    incl %ebx
    movb 1(%esi),%dl
    movw %bx,_PC
    xorb $0xFF,%dl

    E1_SETUPFLAGS
    andb %dl,%al
    orb $0x30,%al
    E1_RESTOREFLAGS

    JUMP_FLAG SNES_FLAG_I,CPU_RETURN
    movb IRQ_pin,%al
    testb %al,%al
    jz  CPU_RETURN
    pushl $CPU_RETURN
    jmp E1_IRQ

/* C3 */

ALIGN
EM_CMP_d_s:
    EM_CMP Stack_Relative
    jmp CPU_RETURN
ALIGN
E0_CMP_d_s:
    E0_CMP Stack_Relative
    jmp CPU_RETURN

/* C4 */

ALIGN
EX_CPY_d:
    EX_CPY Direct
    jmp CPU_RETURN
ALIGN
E0_CPY_d:
    E0_CPY Direct
    jmp CPU_RETURN

/* C5 */

ALIGN
EM_CMP_d:
    EM_CMP Direct
    jmp CPU_RETURN
ALIGN
E0_CMP_d:
    E0_CMP Direct
    jmp CPU_RETURN

/* C6 */

ALIGN
EM_DEC_d:
    EM_DEC Direct
    jmp CPU_RETURN
ALIGN
E0_DEC_d:
    E0_DEC Direct
    jmp CPU_RETURN

/* C7 */

ALIGN
EM_CMP_IdI:
    EM_CMP Direct_Indirect_Long
    jmp CPU_RETURN
ALIGN
E0_CMP_IdI:
    E0_CMP Direct_Indirect_Long
    jmp CPU_RETURN

/* C8 */

ALIGN
EX_INY:
    movw %bx,_PC
    incb _Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_INY:
    movw %bx,_PC
    incw _Y
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* C9 */

ALIGN
EM_CMP_i:
    EM_CMP Immediate
    jmp CPU_RETURN
ALIGN
E0_CMP_i:
    E0_CMP Immediate
    jmp CPU_RETURN

/* CA */

ALIGN
EX_DEX:
    movw %bx,_PC
    decb _X
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_DEX:
    movw %bx,_PC
    decw _X
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* CB */

ALIGN
ALL_WAI:            // Wait for interrupt
    movl $-1,In_WAI
    movl IRQTrip,%eax
    cmpl %ebp,%eax
    js  CPU_RETURN
    movl %eax,%ebp
    jmp CPU_RETURN

/* CC */

ALIGN
EX_CPY_a:
    EX_CPY Absolute
    jmp CPU_RETURN
ALIGN
E0_CPY_a:
    E0_CPY Absolute
    jmp CPU_RETURN

/* CD */

ALIGN
EM_CMP_a:
    EM_CMP Absolute
    jmp CPU_RETURN
ALIGN
E0_CMP_a:
    E0_CMP Absolute
    jmp CPU_RETURN

/* CE */

ALIGN
EM_DEC_a:
    EM_DEC Absolute
    jmp CPU_RETURN
ALIGN
E0_DEC_a:
    E0_DEC Absolute
    jmp CPU_RETURN

/* CF */

ALIGN
EM_CMP_al:
    EM_CMP Absolute_Long
    jmp CPU_RETURN
ALIGN
E0_CMP_al:
    E0_CMP Absolute_Long
    jmp CPU_RETURN

