/*

 65c816 opcodes 0xD0-0xDF:
    D0: BNE r       2,2
    D1: CMP (d),y   2,5
    D2: CMP (d)     2,5
    D3: CMP (d,s),y 2,7
    D4: PEI s       2,6
    D5: CMP d,x     2,4
    D6: DEC d,x     2,6
    D7: CMP [d],y   2,6
    D8: CLD i       1,2
    D9: CMP a,y     3,4
    DA: PHX s       1,3
    DB: STP i       1,3
    DC: JML (a)     3,6
    DD: CMP a,x     3,4
    DE: DEC a,x     3,7
    DF: CMP al,x    4,5
*/

/* D0 */

ALIGN
ALL_BNE:
    BFC SNES_FLAG_Z
    jmp CPU_RETURN

/* D1 */

ALIGN
EM_CMP_OdO_y:
    EM_CMP Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_CMP_OdO_y:
    E0_CMP Direct_Indirect_Indexed
    jmp CPU_RETURN

/* D2 */

ALIGN
EM_CMP_OdO:
    EM_CMP Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_CMP_OdO:
    E0_CMP Direct_Indirect
    jmp CPU_RETURN

/* D3 */

ALIGN
EM_CMP_Od_sO_y:
    EM_CMP Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_CMP_Od_sO_y:
    E0_CMP Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* D4 */

ALIGN
E0_PEI:
    ADDR_Direct_Indirect
    movl %ebx,%eax
	E0_PUSH_W
    jmp CPU_RETURN

ALIGN
E1_PEI:
    ADDR_Direct_Indirect
    movl %ebx,%eax
	E1_PUSH_W
    jmp CPU_RETURN

/* D5 */

ALIGN
EM_CMP_d_x:
    EM_CMP Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_CMP_d_x:
    E0_CMP Direct_Index_X
    jmp CPU_RETURN

/* D6 */

ALIGN
EM_DEC_d_x:
    EM_DEC Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_DEC_d_x:
    E0_DEC Direct_Index_X
    jmp CPU_RETURN

/* D7 */

ALIGN
EM_CMP_IdI_y:
    EM_CMP Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_CMP_IdI_y:
    E0_CMP Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* D8 */

ALIGN
ALL_CLD:
    movw %bx,_PC
	CLR_FLAG SNES_FLAG_D
    jmp CPU_RETURN

/* D9 */

ALIGN
EM_CMP_a_y:
    EM_CMP Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_CMP_a_y:
    E0_CMP Absolute_Index_Y
    jmp CPU_RETURN

/* DA */

ALIGN
E0_PHX:
    movw %bx,_PC
    movw _X,%ax
	E0_PUSH_W
    jmp CPU_RETURN

ALIGN
EX_PHX:
    movw %bx,_PC
    movb _X,%al
	E0_PUSH_B
    jmp CPU_RETURN

ALIGN
E1_PHX:
    movw %bx,_PC
    movb _X,%al
	E1_PUSH_B
    jmp CPU_RETURN

/* DC */

/*
 JML Absolute Indirect Long
  PB:PC = [a16]
*/
ALIGN
ALL_JML_OaO:
    movb 1(%esi),%al
    movb 2(%esi),%ah
    movl %eax,%ebx
    GET_BYTE
    incl %ebx
    movb %al,_PC
    GET_BYTE
    incl %ebx
    movb %al,_PC+1
    movb %al,%ah
    GET_BYTE
    movb %al,_PB
    testb %al,MEMSEL    // Check bus speed against PB
    movb $5,%dl
    jnz 0f
    movb $4,%dl
0:  movb %dl,CycleTable // Update bus speed
    shrb $8,%ah
    movl _Read_BankMapping(,%eax,4),%ebx
    adcl %eax,%eax
    movl %ebx,_PB_Read
    movl _Read_BankOffset(,%eax,4),%eax
    movl %eax,_PBOffset
    jmp CPU_RETURN

/* DD */

ALIGN
EM_CMP_a_x:
    EM_CMP Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_CMP_a_x:
    E0_CMP Absolute_Index_X
    jmp CPU_RETURN

/* DE */

ALIGN
EM_DEC_a_x:
    EM_DEC Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_DEC_a_x:
    E0_DEC Absolute_Index_X
    jmp CPU_RETURN

/* DF */

ALIGN
EM_CMP_al_x:
    EM_CMP Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_CMP_al_x:
    E0_CMP Absolute_Long_Index_X
    jmp CPU_RETURN

