/*

 65c816 opcodes 0xE0-0xEF:
    E0: CPX #       2,2
    E1: SBC (d,x)   2,6
    E2: SEP #       2,3
    E3: SBC d,s     2,4
    E4: CPX d       2,3
    E5: SBC d       2,3
    E6: INC d       2,5
    E7: SBC [d]     2,6
    E8: INX i       1,2
    E9: SBC #       2,2
    EA: NOP i       1,2
    EB: XBA i       1,3
    EC: CPX a       3,4
    ED: SBC a       3,4
    EE: INC a       3,6
    EF: SBC al      4,5
*/

/* E0 */

ALIGN
EX_CPX_i:
    EX_CPX Immediate
    jmp CPU_RETURN
ALIGN
E0_CPX_i:
    E0_CPX Immediate
    jmp CPU_RETURN

/* E1 */

ALIGN
EM_SBC_Od_xO:
    EM_SBC Direct_Indexed_Indirect
    jmp CPU_RETURN
ALIGN
E0_SBC_Od_xO:
    E0_SBC Direct_Indexed_Indirect
    jmp CPU_RETURN

/* E2 */

ALIGN
E0_SEP:
    incl %ebx
    movb 1(%esi),%dl
    movw %bx,_PC

    E0_SETUPFLAGS
    orb %dl,%al
    E0_RESTOREFLAGS

    SET_TABLE_MX

ALIGN
E1_SEP:
    incl %ebx
    movb 1(%esi),%dl
    movw %bx,_PC

    E1_SETUPFLAGS
    orb %dl,%al
    E1_RESTOREFLAGS

    jmp CPU_RETURN

/* E3 */

ALIGN
EM_SBC_d_s:
    EM_SBC Stack_Relative
    jmp CPU_RETURN
ALIGN
E0_SBC_d_s:
    E0_SBC Stack_Relative
    jmp CPU_RETURN

/* E4 */

ALIGN
EX_CPX_d:
    EX_CPX Direct
    jmp CPU_RETURN
ALIGN
E0_CPX_d:
    E0_CPX Direct
    jmp CPU_RETURN

/* E5 */

ALIGN
EM_SBC_d:
    EM_SBC Direct
    jmp CPU_RETURN
ALIGN
E0_SBC_d:
    E0_SBC Direct
    jmp CPU_RETURN

/* E6 */

ALIGN
EM_INC_d:
    EM_INC Direct
    jmp CPU_RETURN
ALIGN
E0_INC_d:
    E0_INC Direct
    jmp CPU_RETURN

/* E7 */

ALIGN
EM_SBC_IdI:
    EM_SBC Direct_Indirect_Long
    jmp CPU_RETURN
ALIGN
E0_SBC_IdI:
    E0_SBC Direct_Indirect_Long
    jmp CPU_RETURN

/* E8 */

ALIGN
EX_INX:
    movw %bx,_PC
    incb _X
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E0_INX:
    movw %bx,_PC
    incw _X
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* E9 */

ALIGN
EM_SBC_i:
    EM_SBC Immediate
    jmp CPU_RETURN
ALIGN
E0_SBC_i:
    E0_SBC Immediate
    jmp CPU_RETURN

/* EA */

ALIGN
ALL_NOP:
    movw %bx,_PC
    jmp CPU_RETURN

/* EB */

ALIGN
ALL_XBA:
    movl _A,%eax
    xchgb %al,%ah
    movw %bx,_PC
    movl %eax,_A
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* EC */

ALIGN
EX_CPX_a:
    EX_CPX Absolute
    jmp CPU_RETURN
ALIGN
E0_CPX_a:
    E0_CPX Absolute
    jmp CPU_RETURN

/* ED */

ALIGN
EM_SBC_a:
    EM_SBC Absolute
    jmp CPU_RETURN
ALIGN
E0_SBC_a:
    E0_SBC Absolute
    jmp CPU_RETURN

/* EE */

ALIGN
EM_INC_a:
    EM_INC Absolute
    jmp CPU_RETURN
ALIGN
E0_INC_a:
    E0_INC Absolute
    jmp CPU_RETURN

/* EF */

ALIGN
EM_SBC_al:
    EM_SBC Absolute_Long
    jmp CPU_RETURN
ALIGN
E0_SBC_al:
    E0_SBC Absolute_Long
    jmp CPU_RETURN
