/*

 65c816 opcodes 0xF0-0xFF:
    F0: BEQ r       2,2
    F1: SBC (d),y   2,5
    F2: SBC (d)     2,5
    F3: SBC (d,s),y 2,7
    F4: PEA s       3,5
    F5: SBC d,x     2,4
    F6: INC d,x     2,6
    F7: SBC [d],y   2,6
    F8: SED i       1,2
    F9: SBC a,y     3,4
    FA: PLX s       1,4
    FB: XCE i       1,2
    FC: JSR (a,x)   3,6
    FD: SBC a,x     3,4
    FE: INC a,x     3,7
    FF: SBC al,x    4,5
*/

/* F0 */

ALIGN
ALL_BEQ:
    BFS SNES_FLAG_Z
    jmp CPU_RETURN

/* F1 */

ALIGN
EM_SBC_OdO_y:
    EM_SBC Direct_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_SBC_OdO_y:
    E0_SBC Direct_Indirect_Indexed
    jmp CPU_RETURN

/* F2 */

ALIGN
EM_SBC_OdO:
    EM_SBC Direct_Indirect
    jmp CPU_RETURN
ALIGN
E0_SBC_OdO:
    E0_SBC Direct_Indirect
    jmp CPU_RETURN

/* F3 */

ALIGN
EM_SBC_Od_sO_y:
    EM_SBC Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN
ALIGN
E0_SBC_Od_sO_y:
    E0_SBC Stack_Relative_Indirect_Indexed
    jmp CPU_RETURN

/* F4 */

ALIGN
E0_PEA:
    addl $2,%ebx
    movb 1(%esi),%al
    movw %bx,_PC
    movb 2(%esi),%ah
    E0_PUSH_W
    jmp CPU_RETURN

ALIGN
E1_PEA:
    addl $2,%ebx
    movb 1(%esi),%al
    movw %bx,_PC
    movb 2(%esi),%ah
    E1_PUSH_W
    jmp CPU_RETURN

/* F5 */

ALIGN
EM_SBC_d_x:
    EM_SBC Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_SBC_d_x:
    E0_SBC Direct_Index_X
    jmp CPU_RETURN

/* F6 */

ALIGN
EM_INC_d_x:
    EM_INC Direct_Index_X
    jmp CPU_RETURN
ALIGN
E0_INC_d_x:
    E0_INC Direct_Index_X
    jmp CPU_RETURN

/* F7 */

ALIGN
EM_SBC_IdI_y:
    EM_SBC Direct_Indirect_Indexed_Long
    jmp CPU_RETURN
ALIGN
E0_SBC_IdI_y:
    E0_SBC Direct_Indirect_Indexed_Long
    jmp CPU_RETURN

/* F8 */

ALIGN
ALL_SED:
    movw %bx,_PC
	SET_FLAG SNES_FLAG_D
    jmp CPU_RETURN

/* F9 */

ALIGN
EM_SBC_a_y:
    EM_SBC Absolute_Index_Y
    jmp CPU_RETURN
ALIGN
E0_SBC_a_y:
    E0_SBC Absolute_Index_Y
    jmp CPU_RETURN

/* FA */

ALIGN
E0_PLX:
    movw %bx,_PC
    E0_PULL_W
    movl %eax,_X
    testw %ax,%ax
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
EX_PLX:
    movw %bx,_PC
    E0_PULL_B
    movb %al,_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN
ALIGN
E1_PLX:
    movw %bx,_PC
    E1_PULL_B
    movb %al,_X
    testb %al,%al
    STORE_FLAGS (SNES_FLAG_NZ)
    jmp CPU_RETURN

/* FB */

ALIGN
E0_XCE:
    movw %bx,_PC

    JUMP_NOT_FLAG SNES_FLAG_C,CPU_RETURN
    xorl %edx,%edx
    movb %dl,_X+1
    movb %dl,_Y+1
    CLR_FLAG(SNES_FLAG_C)
    SET_FLAG(SNES_FLAG_E+SNES_FLAG_B1)
    movb $0x01,_S+1         // Make High S=0x01
    movl $OpTableE1,OpTable // Set current opcode emulation table
    jmp CPU_RETURN

ALIGN
E1_XCE:
    movw %bx,_PC

    JUMP_FLAG SNES_FLAG_C,0f
    SET_FLAG(SNES_FLAG_C+SNES_FLAG_MX)
    CLR_FLAG(SNES_FLAG_E)
    movl $OpTableMX,OpTable // Set current opcode emulation table
    jmp CPU_RETURN
ALIGN
0:  SET_FLAG(SNES_FLAG_B1)
    movb $0x01,_S+1         // Make High S=0x01
    jmp CPU_RETURN

/* FC */

ALIGN
E0_JSR_Oa_xO:
    incl %ebx
    pushl %ebx
    ADDR_Absolute_Indexed_Indirect
    xorl %ebx,%ebx
    addb %al,%al
    movb _PB,%bl
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    movl %eax,_PBOffset
    popl %eax
    E0_PUSH_W
    jmp CPU_RETURN

ALIGN
E1_JSR_Oa_xO:
    incl %ebx
    pushl %ebx
    ADDR_Absolute_Indexed_Indirect
    xorl %ebx,%ebx
    addb %al,%al
    movb _PB,%bl
    adcl %ebx,%ebx
    movl _Read_BankOffset(,%ebx,4),%eax
    movl %eax,_PBOffset
    popl %eax
    E1_PUSH_W
    jmp CPU_RETURN

/* FD */

ALIGN
EM_SBC_a_x:
    EM_SBC Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_SBC_a_x:
    E0_SBC Absolute_Index_X
    jmp CPU_RETURN

/* FE */

ALIGN
EM_INC_a_x:
    EM_INC Absolute_Index_X
    jmp CPU_RETURN
ALIGN
E0_INC_a_x:
    E0_INC Absolute_Index_X
    jmp CPU_RETURN

/* FF */

ALIGN
EM_SBC_al_x:
    EM_SBC Absolute_Long_Index_X
    jmp CPU_RETURN
ALIGN
E0_SBC_al_x:
    E0_SBC Absolute_Long_Index_X
    jmp CPU_RETURN
