/*

 This contains variable and function defintions used by both ASM and C++

 Many of these will be moved to other files as soon as I figure out where
  they belong...

*/

#include <stdio.h>
#include <unistd.h>

#include "wrapaleg.h"   // Wrapper header for Allegro

DECLARE_GFX_DRIVER_LIST(
 GFX_DRIVER_VBEAF
 GFX_DRIVER_VGA
 GFX_DRIVER_MODEX
 GFX_DRIVER_VESA3
 GFX_DRIVER_VESA2L
 GFX_DRIVER_VESA2B
 GFX_DRIVER_XTENDED
 GFX_DRIVER_VESA1
)

DECLARE_COLOR_DEPTH_LIST(
 COLOR_DEPTH_8
 COLOR_DEPTH_15
 COLOR_DEPTH_16
)

DECLARE_DIGI_DRIVER_LIST(
 DIGI_DRIVER_SOUNDSCAPE
 DIGI_DRIVER_AUDIODRIVE
 DIGI_DRIVER_SB
)

DECLARE_MIDI_DRIVER_LIST()

#include "CPU.h"
#include "SPC.h"

// romload.cc
extern void Wangle__Fv(void);
// memhard.S
extern unsigned char BG1SC,BG2SC,BG3SC,BG4SC,BG12NBA,BG34NBA;
extern unsigned char BGMODE,OBSEL,VMAIN,TM,TS,M7SEL,SETINI;
extern unsigned short BG1HOFS,BG1VOFS,BG2HOFS,BG2VOFS;
extern unsigned short BG3HOFS,BG3VOFS,BG4HOFS,BG4VOFS;
extern unsigned short HiSpriteAddr;

unsigned KEY_UP_1,KEY_DOWN_1,KEY_LEFT_1,KEY_RIGHT_1 __attribute__ ((__aligned__));
unsigned KEY_A_1,KEY_B_1,KEY_X_1,KEY_Y_1;
unsigned KEY_L_1,KEY_R_1,KEY_SELECT_1,KEY_START_1;
unsigned KEY_UP_2,KEY_DOWN_2,KEY_LEFT_2,KEY_RIGHT_2;
unsigned KEY_A_2,KEY_B_2,KEY_X_2,KEY_Y_2;
unsigned KEY_L_2,KEY_R_2,KEY_SELECT_2,KEY_START_2;

extern unsigned char WRAM[131072];     // Buffer for Work RAM
extern unsigned char VRAM[65536];      // Buffer for Video RAM
extern unsigned char SRAM[65536];      // Buffer for Save RAM
extern unsigned char SPCRAM[65536];    // Buffer for SPC RAM/ROM
extern unsigned char OAM[512+32];      // Buffer for OAM

unsigned char *RomReadAdjust;
unsigned char *RomReadAdjust2;
unsigned char *RomHiReadAdjust;
unsigned char *RomHiReadAdjust2;
unsigned char *HRomLinReadAdjust;
unsigned char *HRomHiLinReadAdjust;
unsigned char *TileCache2;
unsigned char *TileCache4;
unsigned char *TileCache8;
unsigned char CacheDirty2[4096];
unsigned char CacheDirty4[2048];
unsigned char CacheDirty8[1024];

unsigned short ScreenX,ScreenY;
unsigned char MOUSE_PLUGGED_IN;

/*

unsigned long SNESPatch[10];	// Used to Apply Patches!
unsigned long *SNESPatchPtr=&SNESPatch[0];
unsigned long NumPatches=0;


	movl _NumPatches,%ecx
	movl _SNESPatchPtr,%edx
	cmpl $0,%ecx
	je 0f
1:
	movl (%edx),%esi
	movl %esi,%eax
	andl $0x00FFFFFF,%esi
	shrl $24,%eax
	SET_BYTE
	decl %ecx
	jne 1b
0:

 SNESPatch[0]=0x3F7E0B9D;
 NumPatches=1;

*/

typedef struct {
 unsigned short blue  :5;
 unsigned short green :6;
 unsigned short red   :5;
} colorRGB565;

typedef struct {
 unsigned short red   :5;
 unsigned short green :5;
 unsigned short blue  :5;
 unsigned short fill  :1;
} colorBGR555;

RGB SNES_Palette[256];                  // So I can access from cc modules!
colorBGR555 Real_SNES_Palette[256];     // Updated by palette write
colorRGB565 HICOLOUR_Palette[256][2];   // values in here are plotted direct to PC!
unsigned char BrightnessAdjust[16][256];// Used for faster divides etc.

/*
 This sets up BrightnessAdjust to be 16 tables each with 256 elements;
  table t, element e contains (t+1)e/16.
 This table is used for SNES brightness effects.
 This function may eventually be expanded to set up other tables.
*/
void SetupTables(void){
 int t;
 for (t=0;t<16;t++){
  int e;
  for (e=0;e<256;e++){
   BrightnessAdjust[t][e]=(t+1)*e/16;
  }
 }
}

void Reset_CGRAM(void){
 int i;
 for(i=0;i<256;i++){
  Real_SNES_Palette[i].red=0;
  Real_SNES_Palette[i].green=0;
  Real_SNES_Palette[i].blue=0;
 }
}

#ifdef DEBUG
unsigned long Frames;
#endif

extern unsigned M7X,M7Y,M7A,M7B,M7C,M7D;

unsigned long Map_Address;
unsigned char Map_Byte;

// Mode 0 = 320x200x256 VGA     : Mode 1 = 320x200x256 VGA  FIT
// Mode 2 = 320x240x256 MODE-X  : Mode 3 = 256x256x256 MODE-X
// Mode 4 = 320x200x16b SVGA    : Mode 5 = 320x240x16b SVGA
// Mode 6 = 640x480x16b SVGA    : Mode 7 = 640x480x16b SVGA FIT
unsigned char PC_SCREEN_MODE=0;

unsigned char *SNES_Screen;

BITMAP *Allegro_Bitmap=0;   // Renamed (I'm using mostly allegro now so what the hell!)

unsigned long FRAME_SKIP_MIN;   // Min frames waited until refresh
unsigned long FRAME_SKIP_MAX;   // Max frames waited until refresh
unsigned char SNES_COUNTRY; // Used for PAL/NTSC protection checks
unsigned char JOYSTICK_ENABLED=0;
unsigned char JOYSTICK_ENABLED2=0;
unsigned char SPC_ENABLED=0;

unsigned long BKG;

unsigned short MickeyRead;	// MSB = Yyyyyyyy  LSB = Xxxxxxxx
unsigned char MouseButts;

void MickeyMouse(){
 int mx,my;

 get_mouse_mickeys(&mx,&my);

 MouseButts=mouse_b << 6;   // save button state at time of read

 MickeyRead=0;
 if(mx<0){
  MickeyRead|=0x80;
  mx=-mx;
 }
 MickeyRead|=(mx>>1)&0x7F;
 if(my<0){
  MickeyRead|=0x8000;
  my=-my;
 }
 MickeyRead|=((my>>1)&0x7F)<<8;
}

void InvalidDMAMode(){
 set_gfx_mode(GFX_TEXT,0,0,0,0);
 printf("\nUnsupported DMA mode! - 0x%02X",(unsigned char) Map_Byte);
 exit(-1);
}

unsigned char BrightnessLevel;  // SNES Brightness level, set up in PPU.s

char fixedpalettecheck=0;

// v0.15, we do palette conversion here
// v0.20, support for brightness effects in 16-bit modes
void SetPalette(){
 /* NB - CGRamAddress[256*2] contains 256 palette entries as follows:
         CGRamAddress[0*2+0] contains GGGRRRRR  R = Red component
         CGRamAddress[0*2+1] contains 0BBBBBGG  G = Green component
                                                B = Blue component

    So each 2 addresses contains 1 palette entry.
 */
 
 colorBGR555 color;
 colorRGB565 Hi;
 unsigned char Red,Green,Blue;
 int Count;

 if(PC_SCREEN_MODE>3){  // Hi colour mode so do different palette set up
  for(Count=0;Count<256;Count++){
   color=Real_SNES_Palette[Count];

   Red=BrightnessAdjust[BrightnessLevel][color.red<<3];
   Green=BrightnessAdjust[BrightnessLevel][color.green<<3];
   Blue=BrightnessAdjust[BrightnessLevel][color.blue<<3];

   Hi.red=Red>>3;
   Hi.green=Green>>2;
   Hi.blue=Blue>>3;
   HICOLOUR_Palette[Count][0]=Hi;
   HICOLOUR_Palette[Count][1]=Hi;

   SNES_Palette[Count].r=Red>>2;    // We still have to do this or save pcx
   SNES_Palette[Count].g=Green>>2;  // will fail
   SNES_Palette[Count].b=Blue>>2;
  }
 } else {
  for(Count=0;Count<256;Count++){
   color=Real_SNES_Palette[Count];

   Red=BrightnessAdjust[BrightnessLevel][color.red<<3];
   Green=BrightnessAdjust[BrightnessLevel][color.green<<3];
   Blue=BrightnessAdjust[BrightnessLevel][color.blue<<3];

   SNES_Palette[Count].r=Red>>2;
   SNES_Palette[Count].g=Green>>2;
   SNES_Palette[Count].b=Blue>>2;
  }
 }
 set_palette_range((RGB *)SNES_Palette, 0, 255, FALSE);
}

void CopySNESScreen(){
 blit(Allegro_Bitmap,screen,0,0,0,0,ScreenX,ScreenY);
}

void OutputScreen(){
 static int ScreenCount = 0;    // Used to determine screen filename
 PALETTE ScreenShotPalette;
 char filename[13];

 while (ScreenCount <= 999){
  sprintf(filename, "PICCY%03u.PCX", ScreenCount++);
  if (access(filename, F_OK)) break;
 }
 if (ScreenCount > 999){ ScreenCount = 0; return; }

 get_palette(ScreenShotPalette);
 save_pcx(filename, Allegro_Bitmap, ScreenShotPalette);
}

#ifdef DEBUG

void InvalidHWRead(){
 set_gfx_mode(GFX_TEXT,0,0,0,0);
 printf("\nRead from unsupported HW address! - %02X:%04X",
  (unsigned char) (Map_Address >> 16),(unsigned short) Map_Address);
 exit(0);
}

void InvalidSPCHWRead()
 {
/*
 printf("\nRead from unsupported SPC HW address! - %04X",
  (unsigned short) Map_Address);*/
 }

void InvalidSPCROMWrite()
 {
/*
 printf("\nWrite to SPC ROM ignored - %04X with 0x%02X",
  (unsigned short) Map_Address,(unsigned char) Map_Byte);*/
 }

void InvalidSPCHWWrite()
 {
/*
 printf("\nWrite to unsupported SPC HW address! - %04X with 0x%02X",
  (unsigned short) Map_Address,(unsigned char) Map_Byte);*/
 }

void InvalidROMWrite()
 {
/*
 printf("\nWrite to ROM ignored - %02X:%04X with 0x%02X",
  (unsigned char) (Map_Address >> 16),(unsigned short) Map_Address,
  (unsigned char) Map_Byte);*/
 }

void InvalidHWWrite()
 {
/*
 printf("\nWrite to unsupported HW address! - %02X:%04X with 0x%02X",
  (unsigned char) (Map_Address >> 16),(unsigned short) Map_Address,
  (unsigned char) Map_Byte);*/
 }
#endif

void DisplayStatus();

const char *CPU_OpID[256] = {
/* 00 */ "BRK"      ,"ORA (d,x)","COP"      ,"ORA d,s"      ,
/* 04 */ "TSB d"    ,"ORA d"    ,"ASL d"    ,"ORA [d]"      ,
/* 08 */ "PHP"      ,"ORA i"    ,"SLA"      ,"PHD"          ,
/* 0C */ "TSB a"    ,"ORA a"    ,"ASL a"    ,"ORA al"       ,

/* 10 */ "BPL r"    ,"ORA (d),y","ORA (d)"  ,"ORA (d,s),y"  ,
/* 14 */ "TRB d"    ,"ORA d,x"  ,"ASL d,x"  ,"ORA [d],y"    ,
/* 18 */ "CLC"      ,"ORA a,y"  ,"INA"      ,"TCS"          ,
/* 1C */ "TRB a"    ,"ORA a,x"  ,"ASL a,x"  ,"ORA al,x"     ,

/* 20 */ "JSR a"    ,"AND (d,x)","JSL al"   ,"AND d,s"      ,
/* 24 */ "BIT d"    ,"AND d"    ,"ROL d"    ,"AND [d]"      ,
/* 28 */ "PLP"      ,"AND i"    ,"RLA"      ,"PLD"          ,
/* 2C */ "BIT a"    ,"AND a"    ,"ROL a"    ,"AND al"       ,

/* 30 */ "BMI r"    ,"AND (d),y","AND (d)"  ,"AND (d,s),y"  ,
/* 34 */ "BIT d,x"  ,"AND d,x"  ,"ROL d,x"  ,"AND [d],y"    ,
/* 38 */ "SEC"      ,"AND a,y"  ,"DEA"      ,"TSC"          ,
/* 3C */ "BIT a,x"  ,"AND a,x"  ,"ROL a,x"  ,"AND al,x"     ,

/* 40 */ "RTI"      ,"EOR (d,x)","WDM *"    ,"EOR d,s"      ,
/* 44 */ "MVP"      ,"EOR d"    ,"LSR d"    ,"EOR [d]"      ,
/* 48 */ "PHA"      ,"EOR i"    ,"SRA"      ,"PHK"          ,
/* 4C */ "JMP a"    ,"EOR a"    ,"LSR a"    ,"EOR al"       ,

/* 50 */ "BVC r"    ,"EOR (d),y","EOR (d)"  ,"EOR (d,s),y"  ,
/* 54 */ "MVN"      ,"EOR d,x"  ,"LSR d,x"  ,"EOR [d],y"    ,
/* 58 */ "CLI"      ,"EOR a,y"  ,"PHY"      ,"TCD"          ,
/* 5C */ "JML al"   ,"EOR a,x"  ,"LSR a,x"  ,"EOR al,x"     ,

/* 60 */ "RTS"      ,"ADC (d,x)","PER"      ,"ADC d,s"      ,
/* 64 */ "STZ d"    ,"ADC d"    ,"ROR d"    ,"ADC [d]"      ,
/* 68 */ "PLA"      ,"ADC i"    ,"RRA"      ,"RTL"          ,
/* 6C */ "JMP (a)"  ,"ADC a"    ,"ROR a"    ,"ADC al"       ,

/* 70 */ "BVS r"    ,"ADC (d),y","ADC (d)"  ,"ADC (d,s),y"  ,
/* 74 */ "STZ d,x"  ,"ADC d,x"  ,"ROR d,x"  ,"ADC [d],y"    ,
/* 78 */ "SEI"      ,"ADC a,y"  ,"PLY"      ,"TDC"          ,
/* 7C */ "JMP (a,x)","ADC a,x"  ,"ROR a,x"  ,"ADC al,x"     ,

/* 80 */ "BRA r"    ,"STA (d,x)","BRL rl"   ,"STA d,s"      ,
/* 84 */ "STY d"    ,"STA d"    ,"STX d"    ,"STA [d]"      ,
/* 88 */ "DEY"      ,"BIT i"    ,"TXA"      ,"PHB"          ,
/* 8C */ "STY a"    ,"STA a"    ,"STX a"    ,"STA al"       ,

/* 90 */ "BCC r"    ,"STA (d),y","STA (d)"  ,"STA (d,s),y"  ,
/* 94 */ "STY d,x"  ,"STA d,x"  ,"STX d,y"  ,"STA [d],y"    ,
/* 98 */ "TYA"      ,"STA a,y"  ,"TXS"      ,"TXY"          ,
/* 9C */ "STZ a"    ,"STA a,x"  ,"STZ a,x"  ,"STA al,x"     ,

/* A0 */ "LDY i"    ,"LDA (d,x)","LDX i"    ,"LDA d,s"      ,
/* A4 */ "LDY d"    ,"LDA d"    ,"LDX d"    ,"LDA [d]"      ,
/* A8 */ "TAY"      ,"LDA i"    ,"TAX"      ,"PLB"          ,
/* AC */ "LDY a"    ,"LDA a"    ,"LDX a"    ,"LDA al"       ,

/* B0 */ "BCS r"    ,"LDA (d),y","LDA (d)"  ,"LDA (d,s),y"  ,
/* B4 */ "LDY d,x"  ,"LDA d,x"  ,"LDX d,y"  ,"LDA [d],y"    ,
/* B8 */ "CLV"      ,"LDA a,y"  ,"TSX"      ,"TYX"          ,
/* BC */ "LDY a,x"  ,"LDA a,x"  ,"LDX a,y"  ,"LDA al,x"     ,

/* C0 */ "CPY i"    ,"CMP (d,x)","REP i"    ,"CMP d,s"      ,
/* C4 */ "CPY d"    ,"CMP d"    ,"DEC d"    ,"CMP [d]"      ,
/* C8 */ "INY"      ,"CMP i"    ,"DEX"      ,"WAI"          ,
/* CC */ "CPY a"    ,"CMP a"    ,"DEC a"    ,"CMP al"       ,

/* D0 */ "BNE r"    ,"CMP (d),y","CMP (d)"  ,"CMP (d,s),y"  ,
/* D4 */ "PEI"      ,"CMP d,x"  ,"DEC d,x"  ,"CMP [d],y"    ,
/* D8 */ "CLD"      ,"CMP a,y"  ,"PHX"      ,"STP *"        ,
/* DC */ "JML (a)"  ,"CMP a,x"  ,"DEC a,x"  ,"CMP al,x"     ,

/* E0 */ "CPX i"    ,"SBC (d,x)","SEP i"    ,"SBC d,s"      ,
/* E4 */ "CPX d"    ,"SBC d"    ,"INC d"    ,"SBC [d]"      ,
/* E8 */ "INX"      ,"SBC i"    ,"NOP"      ,"XBA"          ,
/* EC */ "CPX a"    ,"SBC a"    ,"INC a"    ,"SBC al"       ,

/* F0 */ "BEQ r"    ,"SBC (d),y","SBC (d)"  ,"SBC (d,s),y"  ,
/* F4 */ "PEA"      ,"SBC d,x"  ,"INC d,x"  ,"SBC [d],y"    ,
/* F8 */ "SED"      ,"SBC a,y"  ,"PLX"      ,"XCE"          ,
/* FC */ "JSR (a,x)","SBC a,x"  ,"INC a,x"  ,"SBC al,x"
};

void InvalidOpcode(){
 set_gfx_mode(GFX_TEXT,0,0,0,0);

#ifdef DEBUG
 DisplayStatus();
#endif

 printf("Unemulated 65c816 opcode 0x%02X (%s)\n", Map_Byte, CPU_OpID[Map_Byte]);
 printf("At address %02X:%04X\n",(unsigned char) (Map_Address >> 16),
  (unsigned short) Map_Address);

#ifdef DEBUG
 Wangle__Fv();
#endif

 exit(-1);
}

void DisplaySPC(){
 char Message[9];
 int c;

 printf("SPC registers\n");
 printf("PC:%04X  SP:%04X  NZPBHIVC\n", _SPC_PC, _SPC_SP);
 for (c = 0; c < 8; c++) Message[7 - c] = (_SPC_PSW & (1 << c)) ? '1' : '0';
 Message[8] = 0;
 printf("A:%02X  X:%02X  Y:%02X  %s\n", _SPC_A, _SPC_X, _SPC_Y, Message);

 printf("SPC R  0:%02X  1:%02X  2:%02X  3:%02X\n",
  SPC_PORT0R, SPC_PORT1R, SPC_PORT2R, SPC_PORT3R);
 printf("SPC W  0:%02X  1:%02X  2:%02X  3:%02X\n",
  SPC_PORT0W, SPC_PORT1W, SPC_PORT2W, SPC_PORT3W);
}

#ifdef DEBUG
unsigned long OLD_PC;       // Pre-NMI PB:PC
unsigned char OLD_PB;
extern unsigned char
 APUI00a asm("APUI00a"),APUI00b asm("APUI00b"),APUI00c asm("APUI00c");
unsigned long OLD_SPC_ADDRESS;     // Temporary trying to trap bugs
#endif

const char *SPC_OpID[256] = {
 "NOP"            ,"TCALL 0"        ,"SET1 dp.0"      ,"BBS dp.0,rel"   ,
 "OR A,dp"        ,"OR A,labs"      ,"OR A,(X)"       ,"OR A,(dp+X)"    ,
 "OR A,#imm"      ,"OR dp(d),dp(s)" ,"OR1 C,mem.bit"  ,"ASL dp"         ,
 "ASL labs"       ,"PUSH PSW"       ,"TSET1 labs"     ,"BRK"            ,

 "BPL rel"        ,"TCALL 1"        ,"CLR1 dp.0"      ,"BBC dp.0,rel"   ,
 "OR A,dp+X"      ,"OR A,labs+X"    ,"OR A,labs+Y"    ,"OR A,(dp)+Y"    ,
 "OR dp,#imm"     ,"OR (X),(Y)"     ,"DECW dp"        ,"ROL dp+X"       ,
 "ROL A"          ,"PUSH A"         ,"CBNE dp,rel"    ,"BRA rel"        ,

 "CLRP"           ,"TCALL 2"        ,"SET1 dp.1"      ,"BBS dp.1,rel"   ,
 "AND A,dp"       ,"AND A,labs"     ,"AND A,(X)"      ,"AND A,(dp+X)"   ,
 "AND A,#imm"     ,"AND dp(d),dp(s)","OR1 C,/mem.bit" ,"ASL dp"         ,
 "ASL labs"       ,"PUSH PSW"       ,"TSET1 labs"     ,"BRK"            ,

 "BMI rel"        ,"TCALL 3"        ,"CLR1 dp.1"      ,"BBC dp.1,rel"   ,
 "AND A,dp+X"     ,"AND A,labs+X"   ,"AND A,labs+Y"   ,"AND A,(dp)+Y"   ,
 "AND dp,#imm"    ,"AND (X),(Y)"    ,"INCW dp"        ,"ASL dp+X"       ,
 "ASL A"          ,"INC X"          ,"CMP X,dp"       ,"CALL labs"      ,

 "SETP"           ,"TCALL 4"        ,"SET1 dp.2"      ,"BBS dp.2,rel"   ,
 "EOR A,dp"       ,"EOR A,labs"     ,"EOR A,(X)"      ,"EOR A,(dp+X)"   ,
 "EOR A,#imm"     ,"EOR dp(d),dp(s)","AND1 C,mem.bit" ,"LSR dp"         ,
 "LSR labs"       ,"PUSH X"         ,"TCLR1 labs"     ,"PCALL upage"    ,

 "BVC rel"        ,"TCALL 5"        ,"CLR1 dp.2"      ,"BBC dp.2,rel"   ,
 "EOR A,dp+X"     ,"EOR A,labs+X"   ,"EOR A,labs+Y"   ,"EOR A,(dp)+Y"   ,
 "EOR dp,#imm"    ,"EOR (X),(Y)"    ,"CMPW YA,dp"     ,"LSR dp+X"       ,
 "LSR A"          ,"MOV X,A"        ,"CMP Y,labs"     ,"JMP labs"       ,

 "CLRC"           ,"TCALL 6"        ,"SET1 dp.3"      ,"BBS dp.3,rel"   ,
 "CMP A,dp"       ,"CMP A,labs"     ,"CMP A,(X)"      ,"CMP A,(dp+X)"   ,
 "CMP A,#imm"     ,"CMP dp(d),dp(s)","AND1 C,/mem.bit","ROR dp"         ,
 "ROR labs"       ,"PUSH Y"         ,"DBNZ dp,rel"    ,"RET"            ,

 "BVS rel"        ,"TCALL 7"        ,"CLR1 dp.3"      ,"BBC dp.3,rel"   ,
 "CMP A,dp+X"     ,"CMP A,labs+X"   ,"CMP A,labs+Y"   ,"CMP A,(dp)+Y"   ,
 "CMP dp,#imm"    ,"CMP (X),(Y)"    ,"ADDW YA,dp"     ,"ROR dp+X"       ,
 "ROR A"          ,"MOV A,X"        ,"CMP Y,dp"       ,"RETI"           ,

 "SETC"           ,"TCALL 8"        ,"SET1 dp.4"      ,"BBS dp.4,rel"   ,
 "ADC A,dp"       ,"ADC A,labs"     ,"ADC A,(X)"      ,"ADC A,(dp+X)"   ,
 "ADC A,#imm"     ,"ADC dp(d),dp(s)","EOR1 C,mem.bit" ,"DEC dp"         ,
 "DEC labs"       ,"MOV Y,#imm"     ,"POP PSW"        ,"MOV dp,#imm"    ,

 "BCC rel"        ,"TCALL 9"        ,"CLR1 dp.4"      ,"BBC dp.4,rel"   ,
 "ADC A,dp+X"     ,"ADC A,labs+X"   ,"ADC A,labs+Y"   ,"ADC A,(dp)+Y"   ,
 "ADC dp,#imm"    ,"ADC (X),(Y)"    ,"SUBW YA,dp"     ,"DEC dp+X"       ,
 "DEC A"          ,"MOV X,SP"       ,"DIV YA,X"       ,"XCN A"          ,

 "EI"             ,"TCALL 10"       ,"SET1 dp.5"      ,"BBS dp.5,rel"   ,
 "SBC A,dp"       ,"SBC A,labs"     ,"SBC A,(X)"      ,"SBC A,(dp+X)"   ,
 "SBC A,#imm"     ,"SBC dp(d),dp(s)","MOV1 C,mem.bit" ,"INC dp"         ,
 "INC labs"       ,"CMP Y,#imm"     ,"POP A"          ,"MOV (X)+,A"     ,

 "BCS rel"        ,"TCALL 11"       ,"CLR1 dp.5"      ,"BBC dp.5,rel"   ,
 "SBC A,dp+X"     ,"SBC A,labs+X"   ,"SBC A,labs+Y"   ,"SBC A,(dp)+Y"   ,
 "SBC dp,#imm"    ,"SBC (X),(Y)"    ,"MOVW YA,dp"     ,"INC dp+X"       ,
 "INC A"          ,"MOV SP,X"       ,"DAS A"          ,"MOV A,(X)+"     ,

 "DI"             ,"TCALL 12"       ,"SET1 dp.6"      ,"BBS dp.6,rel"   ,
 "MOV dp,A"       ,"MOV labs,A"     ,"MOV (X),A"      ,"MOV (dp+X),A"   ,
 "CMP X,#imm"     ,"MOV labs,X"     ,"MOV1 mem.bit,C" ,"MOV dp,Y"       ,
 "MOV labs,Y"     ,"MOV X,#imm"     ,"POP X"          ,"MUL YA"         ,

 "BNE rel"        ,"TCALL 13"       ,"CLR1 dp.6"      ,"BBC dp.6,rel"   ,
 "MOV dp+X,A"     ,"MOV labs+X,A"   ,"MOV labs+Y,A"   ,"MOV (dp)+Y,A"   ,
 "MOV dp,X"       ,"MOV dp+Y,X"     ,"MOVW dp,YA"     ,"MOV dp+X,Y"     ,
 "DEC Y"          ,"MOV A,Y"        ,"CBNE dp+X,rel"  ,"DAA A"          ,

 "CLRV"           ,"TCALL 14"       ,"SET1 dp.7"      ,"BBS dp.7,rel"   ,
 "MOV A,dp"       ,"MOV A,labs"     ,"MOV A,(X)"      ,"MOV A,(dp+X)"   ,
 "MOV A,#imm"     ,"MOV X,labs"     ,"NOT1 mem.bit"   ,"MOV Y,dp"       ,
 "MOV Y,labs"     ,"NOTC"           ,"POP Y"          ,"SLEEP"          ,

 "BEQ rel"        ,"TCALL 15"       ,"CLR1 dp.7"      ,"BBC dp.7,rel"   ,
 "MOV A,dp+X"     ,"MOV A,labs+X"   ,"MOV A,labs+Y"   ,"MOV A,(dp)+Y"   ,
 "MOV X,dp"       ,"MOV X,dp+Y"     ,"MOV dp(d),dp(s)","MOV Y,dp+X"     ,
 "INC Y"          ,"MOV Y,A"        ,"DBNZ Y,rel"     ,"STOP"
};

// Simple at present... register dump will be done l8r
void InvalidSPCOpcode(){
 set_gfx_mode(GFX_TEXT,0,0,0,0);

 DisplaySPC();

 printf("Unemulated SPC opcode 0x%02X (%s)\n", Map_Byte, SPC_OpID[Map_Byte]);
 printf("At address 0x%04X\n",(unsigned short) Map_Address);

#ifdef DEBUG
/*
 printf("Old Address 0x%04X\n",(unsigned short) OLD_SPC_ADDRESS);
 */
 Wangle__Fv();      // Output SPC_RAM contents
#endif

 exit(-1);
}

#ifdef DEBUG

extern unsigned long VTIMEL asm("VTIMEL"),HTIMEL asm("HTIMEL");

void DisplayStatus(){
 char Message[10];
 int c;

 printf("\n65c816 registers\n");
 printf("PB:PC %02X:%04X",
  (unsigned char) OLD_PB, (unsigned short) OLD_PC);
 printf("  DB:D  %02X:%04X", _65816_DB, (unsigned short) _65816_D);
 printf("  S:%04X", (unsigned short) _65816_S);
 if(_65816_P&0x100) printf("  ENZIDB1VC\n");
 else printf("  ENZIDXMVC\n");
 printf("A:%04X  X:%04X  Y:%04X", (unsigned short) _65816_A,
  (unsigned short) _65816_X, (unsigned short) _65816_Y);

 for(c = 0; c < 9; c++) Message[8 - c] = (_65816_P & (1 << c)) ? '1' : '0';
 Message[9] = 0;
 printf("  Opcode:%02X     %s\n", (unsigned char) Map_Byte, Message);

 printf("BG1SC:%02X  BG2SC:%02X  BG3SC:%02X  BG4SC:%02X\n",
  BG1SC, BG2SC, BG3SC, BG4SC);

 printf("BG1H:%04X  BG1V:%04X  BG2H:%04X  BG2V:%04X\n",
  (unsigned short) BG1HOFS, (unsigned short) BG1VOFS,
  (unsigned short) BG2HOFS, (unsigned short) BG2VOFS);
 printf("BG3H:%04X  BG3V:%04X  BG4H:%04X  BG4V:%04X\n",
  (unsigned short) BG3HOFS, (unsigned short) BG3VOFS,
  (unsigned short) BG4HOFS, (unsigned short) BG4VOFS);
 printf("BG12NBA:%02X     BG34NBA:%02X\n", BG12NBA, BG34NBA);

 printf("BGMODE:%02X      TM:%02X\n", BGMODE, TM);
 printf("VMAIN:%02X       TS:%02X\n", VMAIN, TS);

 printf("OBSEL:%02X       HiSprite:%02X\n", OBSEL,
  (HiSpriteAddr-(unsigned) OAM) & 0x1FF);
 printf("M7SEL:%02X       SETINI:%02X\n", M7SEL, SETINI);

 printf("M7A:%04X  M7B:%04X  M7C:%04X  M7D:%04X  M7X:%04X  M7Y:%04X\n",
  (unsigned short) M7A, (unsigned short) M7B,
  (unsigned short) M7C, (unsigned short) M7D,
  (unsigned short) M7X, (unsigned short) M7Y);

 if (!SPC_ENABLED){
  printf("  APUI00a:%02X  APUI00b:%02X  APUI00c:%02X\n",
   APUI00a, APUI00b, APUI00c);
 } else {
  DisplaySPC();
 }
 printf("VTIME: %04X HTIME: %04X\n",VTIMEL,HTIMEL);
}

RGB DebugPal[]={{63,63,63,0}};

unsigned char DEBUG_STRING[]="Voice : %d";

unsigned char DEBUG_VALUE1=0;
unsigned char DEBUG_VALUE2=0;
unsigned char DEBUG_VALUE3=0;
unsigned char DEBUG_VALUE4=0;
unsigned char DEBUG_VALUE5=0;
unsigned char DEBUG_VALUE6=0;
unsigned char DEBUG_VALUE7=0;
unsigned char DEBUG_VALUE8=0;

extern unsigned long Throttle asm("Throttle");
void Display_Debug(){
// set_palette_range(&DebugPal[-255],255,255,TRUE);   // Set the GUI palette up.
   textprintf(screen,font,50,50,255,"Throttle: %u",(unsigned long)Throttle);
// textprintf(screen,font,50,50,255,DEBUG_STRING,(int)DEBUG_VALUE1);
// textprintf(screen,font,50,60,255,DEBUG_STRING,(int)DEBUG_VALUE2);
// textprintf(screen,font,50,70,255,DEBUG_STRING,(int)DEBUG_VALUE3);
// textprintf(screen,font,50,80,255,DEBUG_STRING,(int)DEBUG_VALUE4);
// textprintf(screen,font,50,90,255,DEBUG_STRING,(int)DEBUG_VALUE5);
// textprintf(screen,font,50,100,255,DEBUG_STRING,(int)DEBUG_VALUE6);
// textprintf(screen,font,50,110,255,DEBUG_STRING,(int)DEBUG_VALUE7);
// textprintf(screen,font,50,120,255,DEBUG_STRING,(int)DEBUG_VALUE8);
}
#endif
