#ifndef SNEeSe_helper_h
#define SNEeSe_helper_h

#include "misc.h"

EXTERN unsigned
 KEY_UP_1,KEY_DOWN_1,KEY_LEFT_1,KEY_RIGHT_1,
 KEY_A_1,KEY_B_1,KEY_X_1,KEY_Y_1,
 KEY_L_1,KEY_R_1,KEY_SELECT_1,KEY_START_1,
 KEY_UP_2,KEY_DOWN_2,KEY_LEFT_2,KEY_RIGHT_2,
 KEY_A_2,KEY_B_2,KEY_X_2,KEY_Y_2,
 KEY_L_2,KEY_R_2,KEY_SELECT_2,KEY_START_2;

EXTERN unsigned char WRAM[131072];  // Buffer for Work RAM
EXTERN unsigned char VRAM[65536];   // Buffer for Video RAM
EXTERN unsigned char VRAM_DI[65536];// Buffer for Video RAM (deinterleaved)
EXTERN unsigned char SRAM[65536];   // Buffer for Save RAM
EXTERN unsigned char SPCRAM[65536]; // Buffer for SPC RAM/ROM
EXTERN unsigned char Blank[65536];  // Blank ROM buffer
EXTERN unsigned char OAM[512+32];   // Buffer for OAM

EXTERN unsigned char *RomReadAdjust;
EXTERN unsigned char *RomReadAdjust2;
EXTERN unsigned char *RomHiReadAdjust;
EXTERN unsigned char *RomHiReadAdjust2;
EXTERN unsigned char *HRomLinReadAdjust;
EXTERN unsigned char *HRomHiLinReadAdjust;
EXTERN unsigned char *TileCache2;
EXTERN unsigned char *TileCache4;
EXTERN unsigned char *TileCache8;
EXTERN unsigned char CacheDirty2[4096];
EXTERN unsigned char CacheDirty4[2048];
EXTERN unsigned char CacheDirty8[1024];

EXTERN unsigned short ScreenX,ScreenY;
EXTERN unsigned char MOUSE_PLUGGED_IN;

typedef struct {
 unsigned short blue  :5;
 unsigned short green :6;
 unsigned short red   :5;
} colorRGB565;

typedef struct {
 unsigned short red   :5;
 unsigned short green :5;
 unsigned short blue  :5;
 unsigned short fill  :1;
} colorBGR555;

EXTERN unsigned char BrightnessAdjust[16][256];// Used for faster divides etc.
EXTERN RGB SNES_Palette[256];                  // So I can access from cc modules!
EXTERN colorBGR555 Real_SNES_Palette[256];     // Updated by palette write
EXTERN colorRGB565 HICOLOUR_Palette[256][2];   // values in here are plotted direct to PC!

EXTERN void SetupTables(void);
EXTERN void Reset_CGRAM(void);

#ifdef DEBUG
EXTERN unsigned long Frames;
EXTERN unsigned long FrameLimit;
#endif

EXTERN unsigned M7X,M7Y,M7A,M7B,M7C,M7D;

EXTERN unsigned long Map_Address;
EXTERN unsigned char Map_Byte;

EXTERN unsigned short PC_SCREEN_MODE;

EXTERN unsigned char *SNES_Screen;

EXTERN BITMAP *Allegro_Bitmap;  // Renamed (I'm using mostly allegro now so what the hell!)

EXTERN unsigned long FRAME_SKIP_MIN;    // Min frames waited until refresh
EXTERN unsigned long FRAME_SKIP_MAX;    // Max frames waited until refresh
EXTERN unsigned char SNES_COUNTRY;  // Used for PAL/NTSC protection checks
EXTERN unsigned char JOYSTICK_ENABLED;
EXTERN unsigned char JOYSTICK_ENABLED2;
EXTERN unsigned char SPC_ENABLED;

EXTERN unsigned char *BKG;
EXTERN unsigned long VRamTop;

EXTERN unsigned short MickeyRead;   // MSB = Yyyyyyyy  LSB = Xxxxxxxx
EXTERN unsigned char MouseButts;

EXTERN void MickeyMouse(void);
EXTERN void InvalidDMAMode(void);

EXTERN unsigned char BrightnessLevel;   // SNES Brightness level, set up in memhard.s
EXTERN char fixedpalettecheck;

EXTERN void SetPalette(void);
EXTERN void CopySNESScreen(void);

#ifdef DEBUG
EXTERN void InvalidHWRead(void);
EXTERN void InvalidSPCHWRead(void);
EXTERN void InvalidSPCROMWrite(void);
EXTERN void InvalidSPCHWWrite(void);
EXTERN void InvalidROMWrite(void);
EXTERN void InvalidHWWrite(void);
#endif

EXTERN void InvalidOpcode(void);

EXTERN unsigned char S_A,S_X,S_Y;
EXTERN unsigned short S_S,S_PC,S_P;

EXTERN void DisplaySPC(void);

#ifdef DEBUG
EXTERN unsigned long OLD_PC;    // Pre-NMI PB:PC
EXTERN unsigned char OLD_PB;
EXTERN unsigned long OLD_SPC_ADDRESS;   // Temporary trying to trap bugs
#endif

EXTERN void InvalidSPCOpcode(void);

EXTERN void DisplayStatus(void);

EXTERN RGB DebugPal[];

EXTERN unsigned char DEBUG_STRING[];
EXTERN unsigned char DEBUG_VALUE1;
EXTERN unsigned char DEBUG_VALUE2;
EXTERN unsigned char DEBUG_VALUE3;
EXTERN unsigned char DEBUG_VALUE4;
EXTERN unsigned char DEBUG_VALUE5;
EXTERN unsigned char DEBUG_VALUE6;
EXTERN unsigned char DEBUG_VALUE7;
EXTERN unsigned char DEBUG_VALUE8;

EXTERN void Display_Debug(void);

#endif /* SNEeSe_helper_h */
