#ifndef SNEeSe_mem_h
#define SNEeSe_mem_h

#include "misc.h"

// mem.S
EXTERN void UNSUPPORTED_READ(void),UNSUPPORTED_WRITE(void);
EXTERN void RAM_READ(void),RAM_WRITE(void);
EXTERN void SRAM_READ(void),SRAM_WRITE(void);
EXTERN void READ_00_3F_No_SRAM(void),READ_00_3F_2(void),READ_40_5F_2(void);
EXTERN void READ_80_BF_No_SRAM(void),READ_80_BF_2(void),READ_C0_FF_2(void);
EXTERN void WRITE_00_3F(void),WRITE_80_BF(void);
EXTERN void HWRITE_00_2F(void),HWRITE_80_AF(void);
EXTERN void (*Read_BankMapping[256])(void);
EXTERN void (*Write_BankMapping[256])(void);
EXTERN void *Read_BankOffset[512];
EXTERN unsigned long LoROM_Write[256];

// memhi.S
EXTERN void (*HiROM_Read[256])(void),(*HiROM_Write[256])(void);
EXTERN void (*HiROM_Read_SRAM_ROM_30[8])(void);
EXTERN void (*HiROM_Read_SRAM_ROM_B0[8])(void);
EXTERN void (*HiROM_Read_SRAM_Blank_30[8])(void);
EXTERN void (*HiROM_Read_SRAM_Blank_B0[8])(void);
EXTERN void (*HiROM_Write_SRAM_30[8])(void);
EXTERN void (*HiROM_Write_SRAM_B0[8])(void);
EXTERN void (*HiROM_Read_No_SRAM_ROM_30)(void);
EXTERN void (*HiROM_Read_No_SRAM_ROM_B0)(void);
EXTERN void (*HiROM_Read_No_SRAM_Blank_30)(void);
EXTERN void (*HiROM_Read_No_SRAM_Blank_B0)(void);
EXTERN void (*HiROM_Write_No_SRAM_30)(void);
EXTERN void (*HiROM_Write_No_SRAM_B0)(void);

// memblank.S
EXTERN void (*LoROM_Blank[256])(void),(*HiROM_Blank[256])(void);

#endif /* SNEeSe_mem_h */
