.macro	WIPE_SNES_SCREEN
	movl _BKG,%edi
    xorl %eax,%eax
    movl $((256+2*64)*(256+2*64))/4,%ecx
    rep
    stosl
.endm

.macro RenderScanline
    movl ScreenDestPtr,%edi
    movl $256/16,%ebp
    xorl %eax,%eax
    xorl %edx,%edx

ALIGN
0:  movl %eax,0(%edi)
    movl %edx,4(%edi)
    movl %eax,8(%edi)
    movl %edx,12(%edi)
    addl $16,%edi
    decl %ebp
    jnz 0b

    movb _INIDISP,%ah
    testb %ah,%ah       // Check for screen off
    jns 1f

    addl $128,%edi      // Point screen to next line
    jmp 2f

1:  movb SCR_TM,%bl     // Get BG status for main screens
    call *Render_Mode
    movb SCR_TS,%bl     // Get BG status for sub screens
    call *Render_Mode
    movl ScreenDestPtr,%edi
    addl $256+128,%edi  // Point screen to next line
2:  movl %edi,ScreenDestPtr
.endm

// v0.25 - One macro for 8x8 and 16x8 tiles
.macro SORT_TILES_8_TALL
    // parameters: edx
    // uses: eax, ebx, 0-label
    // returns: esi, LineAddress, LineAddressY
    movb Mosaic(%edx),%al
    testb %al,%al
    movl HDMAYCount,%eax
    jz  0f
    movl Mosaic_YCount,%eax
0:
    addl VScroll(%edx),%eax
    shll $3,%eax        // Get screen offset
    movl %eax,%esi
    andl $0x07*8,%eax   // Line offset in tile
    movl $8*7,%ebx
    andl $0xF8*8,%esi   // Current line + V scroll * 32words
    subl %eax,%ebx
    movl %ebx,LineAddressY
    movl %eax,LineAddress
.endm

.macro SORT_TILES_16_TALL
    // parameters: edx
    // uses: eax, ebx, 0-label
    // returns: esi, LineAddress, LineAddressY
    movb Mosaic(%edx),%al
    testb %al,%al
    movl HDMAYCount,%eax
    jz  0f
    movl Mosaic_YCount,%eax
0:
    addl VScroll(%edx),%eax
    shll $2,%eax        // Get screen offset
    movl %eax,%esi
    andl $0x0F*4,%eax   // Offset into table of line offsets
    andl $0x1F0*4,%esi  // Current line + V scroll * 32words
    movl $16*8*8+8*7,%ebx
    movl Tile_Offset_Table_64_8(%eax),%eax
    subl %eax,%ebx
    movl %ebx,LineAddressY
    movl %eax,LineAddress
.endm

.macro CALCULATE_MOSAIC_YLINE BGmask
    // uses: eax, edx, ebp, 0-label
    // returns: Mosaic_YCount
    movb MOSAIC,%al
    testb $\BGmask,%al
    jz  0f
    testb $0xF0,%al
    jz  0f
    movl HDMAYCount,%eax
    movl Mosaic_Size,%ebp
    decl %eax
    xorl %edx,%edx
    divl %ebp
    mull %ebp
    incl %eax
    movl %eax,Mosaic_YCount
0:
.endm

.macro LOAD_BG_TABLE num
    movl $TableBG\num,%edx
.endm
