#ifndef SNEeSe_sound_h
#define SNEeSe_sound_h

#define TIMER_SHIFT 2   // Helps make sound musical
#define PITCH_SHIFT 3

#include "misc.h"

EXTERN unsigned char
 SPC_TIMER0,SPC_TIMER1,SPC_TIMER2,
 SPC_TIMT0 ,SPC_TIMT1 ,SPC_TIMT2 ,
 SPC_TIM0  ,SPC_TIM1  ,SPC_TIM2  ,
 SPC_CNT0  ,SPC_CNT1  ,SPC_CNT2  ,
 SPC_CTRL  ,SPC_MASK,
 SPC_DSP_ADDR, SPC_DSP_DATA, SPC_DSP_ENDX;

EXTERN unsigned long TotalCycles,CycleLatch0,CycleLatch1,CycleLatch2;

EXTERN SAMPLE *test[8];     // We will allocate 64k worth of sample to each of these!
EXTERN int LoopList[8];     // List of if sample should loop or not
EXTERN int VoiceList[16];   // 8 voices, *2 for stereo sound

EXTERN unsigned char SOUND_ENABLED;

EXTERN unsigned char SPC_DSP_Buffer[256];   // DSP Registers
EXTERN unsigned char *SPC_DSP;

EXTERN unsigned char Main_Volume_L,Main_Volume_R;
EXTERN unsigned short Voice_Pitch[8];
EXTERN unsigned char Voice_Volume_L[8],Voice_Volume_R[8];
EXTERN unsigned short Voice_Source[8];
EXTERN unsigned short Source_Directory;

EXTERN void Remove_Sound();
EXTERN int Install_Sound(int stereo);

EXTERN void PlayVoices(int Bits);
EXTERN void StopVoices(int Bits);

EXTERN void SPC_READ_DSP();
EXTERN void SPC_WRITE_DSP();

EXTERN void Sort_Count0();
EXTERN void Sort_Count1();
EXTERN void Sort_Count2();

EXTERN void SPC_DECODE(int DECODE_BYTE);

EXTERN void sound_pause(void);
EXTERN void sound_resume(void);

#endif /* SNEeSe_sound_h */
